
        .MODEL SMALL
        .STACK 512

;------------------------------------------------------------

        INCLUDELIB IO.LIB

        EXTERN     CLEAR:FAR
        EXTERN     NEWLINE:FAR
        EXTERN     PUTSTRNG:FAR
        EXTERN     GETDEC:FAR

;------------------------------------------------------------

        .DATA

EntNumMsg db 'Enter a Fibonacci sequence number: '
OverFlMsg db 'Overflow',13,10
AnyKeyMsg db 'Press any key to continue ...',13,10

MyArr1    db 71 dup(0),0
MyArr2    db 71 dup(0),1
MyArr3    db 72 dup(0)

;------------------------------------------------------------

        .CODE

_main   PROC    FAR

;set the DS register to DGROUP

        mov     ax,@DATA
        mov     ds,ax
        mov     es,ax

;get the user number entry

        call    CLEAR
        call    NEWLINE
        call    NEWLINE
        mov     di,offset EntNumMsg
        mov     cx,sizeof EntNumMsg
        call    PUTSTRNG
        call    GETDEC
        call    NEWLINE

;generate Fibonacci number

        mov     bx,offset MyArr1  ;start with BX = MyArr1
        mov     bp,offset MyArr2  ;start with BP = MyArr2
        mov     si,offset MyArr3  ;start with SI = MyArr3
        mov     dx,10             ;DL = 10, DH = 0
        mov     cx,ax
        jcxz    display

fibonacci_loop:
        push    cx
        mov     di,71             ;index to last digit
        lea     cx,[di+1]         ;calculates 72 for the loop count
        xor     ax,ax             ;start with AX = 0 and XOR always clears the carry flag

add_loop:
        adc     al,[bx+di]        ;add carry flag to digit from value 1
        add     al,ds:[bp+di]     ;add digit from value 2

        sub     al,dl             ;is it > 10 ?
        jnc     no_correction     ;yes - skip correction (carry flag = 0)

        add     al,dl             ;add the 10 back in (carry flag = 1)

no_correction:
        xchg    si,bx             ;we need SI to be in either BP or BX for base+index addressing
        mov     [bx+di],al        ;store the result
        xchg    si,bx             ;switch BX and SI back
        cmc                       ;invert (compliment) the carry flag
        dec     di                ;adjust the index - INC and DEC do not affect the carry flag
        mov     al,dh             ;zero the accumulator
        loop    add_loop          ;loop decrements CX but also does not affect the carry flag

;if CF = 1 at this point, the accumulator has overflowed

        xchg    bp,si             ;rotate the array base addresses
        xchg    bp,bx
        pop     cx
        jc      loop_overflow

        loop    fibonacci_loop    ;loop until overflow occurs

;find the first non-zero digit

display:
        mov     ax,30h            ;AL = '0', AH = 0
        mov     cx,72

lead_zero:
        cmp     ah,[bx]
        jnz     ascii

        inc     bx
        loop    lead_zero

        dec     bx
        inc     cx

;convert the remaining digits to ASCII

ascii:  mov     di,bx             ;save the offset of the first digit
        mov     dx,cx             ;save the count for PUTSTRNG

ascii_loop:
        or      [bx],al
        inc     bx
        loop    ascii_loop

;display the Fibonacci number

        mov     cx,dx
        call    PUTSTRNG
        call    NEWLINE

;display the "any key to continue" message

exit0:
        call    NEWLINE
        mov     di,offset AnyKeyMsg
        mov     cx,sizeof AnyKeyMsg
        call    PUTSTRNG

;wait for a key

        mov     ah,0
        int     16h

;terminate the program

        mov     ax,4C00h
        int     21h

loop_overflow:
        mov     di,offset OverFlMsg
        mov     cx,sizeof OverFlMsg
        call    PUTSTRNG
        jmp     exit0

_main   ENDP

;------------------------------------------------------------

        END     _main

